---
- hosts: srv1
  become: yes
  tasks:

    - name: Install required system packages
      apt:
        pkg:
#          - python3-pip
          - openjdk-11-jdk
          - elasticsearch-curator
        state: latest
        update_cache: true

    - name: Install Elastic
      apt:
        deb: https://mirror.yandex.ru/mirrors/elastic/7/pool/main/e/elasticsearch/elasticsearch-7.17.9-amd64.deb
        state: present  
        allow_unauthenticated: yes

    - name: Install Logstash
      apt:
        deb: https://mirror.yandex.ru/mirrors/elastic/7/pool/main/l/logstash/logstash-7.17.9-amd64.deb
        state: present
        allow_unauthenticated: yes

    - name: Install Kibana
      apt:
        deb: https://mirror.yandex.ru/mirrors/elastic/7/pool/main/k/kibana/kibana-7.17.9-amd64.deb
        state: present
        allow_unauthenticated: yes

    - name: Create build directory
      file:
        path: /root/demo
        state: directory
        owner: root
        group: root
        mode: '0755'

    - name: Copy Kibana/Logstash configs
      copy:
        src: ../src/server
        dest: /root/demo
        owner: root
        group: root
        mode: '0644'

    - name: Copy Logstash config
      copy:
        src: /root/demo/server/logstash.conf
        dest: /etc/logstash/conf.d/
        owner: root
        group: root
        mode: '0644'
        remote_src: yes

    - name: Copy Kibana config
      copy:
        src: /root/demo/server/kibana.yml
        dest: /etc/kibana/kibana.yml
        owner: root
        group: root
        mode: '0644'
        remote_src: yes

    - name: Copy Elastic config
      copy:
        src: ../tf/tmp/elastic-srv1.yml
        dest: /etc/elasticsearch/elasticsearch.yml
        owner: root
        group: root
        mode: '0644'

    - name: Create curator config directory
      file:
        path: /etc/curator
        state: directory
        owner: root
        group: root
        mode: '0644'

    - name: Copy Curator config1
      copy:
        src: /root/demo/server/curator.yml
        dest: /etc/curator/config.yml
        owner: root
        group: root
        mode: '0644'
        remote_src: yes

    - name: Copy Curator config2
      copy:
        src: /root/demo/server/action.yml
        dest: /etc/curator/action.yml
        owner: root
        group: root
        mode: '0644'
        remote_src: yes

    - name: Start Elasticsearch
      systemd:
        name: elasticsearch
        state: restarted
        enabled: yes

    - name: Start Logstash
      systemd:
        name: logstash
        state: restarted
        enabled: yes

    - name: Start Kibana
      systemd:
        name: kibana
        state: restarted
        enabled: yes

    - name: Cron job for curator
      ansible.builtin.cron:
        name: "test"
        state: present
        minute: "*/2"
        hour: "*"
        day: "*"
        month: "*"
        weekday: "*"
        job: '/usr/bin/curator --config /etc/curator/config.yml /etc/curator/action.yml'